#import "Controller.h"

@implementation Controller

- (IBAction)getContents:(id)sender
{
	// ꤷURL
	NSURL *url = [NSURL URLWithString: [selUrl stringValue]];
	BOOL flag;
	int i,j;
	
	// ݤƥ󥹥󥹤
	NSMutableAttributedString *astr = [[NSMutableAttributedString alloc] init];

	// Фܤȡ줾ʸο
	NSArray *key = [NSArray arrayWithObjects:@"title",@"description",@"link",nil]; 
	NSArray *color = [NSArray arrayWithObjects:[NSColor magentaColor],[NSColor grayColor],[NSColor purpleColor],nil];
	NSAttributedString *strCR = [[[NSAttributedString alloc] initWithString:@"\n"] autorelease];

	// ᥤ̤(ɽ򥯥ꥢ)
	[[display textStorage]setAttributedString:astr];

	// ꤷURLǡɤ߹ǡXMLѡ֥Ȥ֤
	NSXMLParser *parser = [[NSXMLParser alloc] initWithContentsOfURL:url];
	// ǥꥲȤ򥻥å
	[parser setDelegate:self];
	// XMLѡ֥Ȥ
	flag = [parser parse];

	// ɤ߹ߤ˼ԤХ顼å
	if ( flag == NO ) {
		[display setEditable:YES];
		[display insertText:@"Cannot read this RSS in ver0.56"];
		[display setEditable:NO];
	} else {
		for ( i = 0; i < [ary count]; i++ ) {
			NSDictionary	*tmpdict = [ary objectAtIndex:i];
			for ( j = 0; j < [key count]; j++ ) {
				NSString *strKey = [key objectAtIndex:j];  // 
				NSColor *color1 = [color objectAtIndex:j]; // 
				NSDictionary *dic = [NSDictionary dictionaryWithObject:color1 forKey:NSForegroundColorAttributeName];
				NSString *contents = [tmpdict objectForKey:strKey];
				NSAttributedString *temp;
				if ( [strKey isEqualToString:@"link"] ) {
					// åƥ֥饦褦ˤƤ
					NSDictionary *attrs = [NSDictionary dictionaryWithObject:contents forKey:NSLinkAttributeName];
					temp = [[NSAttributedString alloc] initWithString:[NSString stringWithFormat:@"%@\n",contents] attributes:attrs];
				} else {
					temp = [[NSAttributedString alloc] initWithString:[NSString stringWithFormat:@"%@\n",contents] attributes:dic];
				}
				[astr appendAttributedString:temp];
				[temp release];
			}
			[astr appendAttributedString:strCR];

		}
		// ᥤ̤˽
		[display setEditable:YES];
		[display insertText:astr];
	}
	// β
	[astr release];
	[parser release];

	// Ƭ˻äƤ
	[display setSelectedRange:NSMakeRange(0,0)];
	[display insertText:@""];
	[display setEditable:NO];
}

// ---------------------------
// ѡ¹
//----------------------------

// Parse
- (void)parserDidStartDocument:(NSXMLParser *)parser
{
	//NSLog(@"start");
	[spin startAnimation:self];

	// 
	dict = [NSMutableDictionary dictionary];
	mustr = [NSMutableString string];
	ary = [NSMutableArray array];
	itemflag = false;
}


// ܼФ (γ)
-(void)parser:(NSXMLParser *)parser
		didStartElement:(NSString *)elementName
		namespaceURI:(NSString *)namespaceURI
		qualifiedName:(NSString *)qName
		attributes:(NSDictionary *)attributeDict
{
	// إåʬȴ<item>ȤФ褦ˤ
	if ( [elementName isEqualToString:@"item"] ) {
		itemflag = true;
	}
}

// ǰϤޤ줿ʸФ
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
	NSMutableString *tempstr = [NSMutableString string];
	[tempstr appendString:string];
	// ڡ
    CFStringTrimWhitespace( (CFMutableStringRef)tempstr );
	[mustr appendString:tempstr];
}

// ܼФλ (νλ)
-(void)parser:(NSXMLParser *)parser
		didEndElement:(NSString *)elementName
		namespaceURI:(NSString *)namespaceURI
		qualifiedName:(NSString *)qName
{
	// </item>θ̵ˤ
	if ( [elementName isEqualToString:@"item"] ) {
		// <title><description><link>򥻥åȤˤƳǼ
		[ary addObject:[dict copy]];
		[dict removeAllObjects];
		itemflag = false;
	}
	
	if ( itemflag == true ) {
		// <item><title><description><link>ƤϿ
		if ( [elementName isEqualToString:@"title"] || [elementName isEqualToString:@"description"] 
			|| [elementName isEqualToString:@"link"]) {
				[dict setObject:[mustr copy] forKey:elementName];
		}
	}
	[mustr setString:@""];
}

// Parseλ
- (void)parserDidEndDocument:(NSXMLParser *)parser
{
	[spin stopAnimation:self];
}

// ---------------------------
// ץꥱ
//----------------------------

//ץꥱεư
// Ķɤ߹
- (void) applicationDidFinishLaunching:(NSNotification *)aNotification
{
	[spin setDisplayedWhenStopped:NO];
	NSUserDefaults *defaults = [ NSUserDefaults standardUserDefaults ];
	id sel = [defaults objectForKey:@"listUrl"];
	[selUrl setUsesDataSource:NO];
	[selUrl addItemsWithObjectValues:sel];
}

// ץꥱλ
// Ķ¸
- (void)windowWillClose:(NSNotification *)aNotification
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSArray *temp = [[NSArray alloc] initWithArray:[selUrl objectValues] ];
	[selUrl setUsesDataSource:NO];
	[defaults setObject:temp forKey:@"listUrl"];
	[defaults synchronize];
}

// ɥĤХץꥱλ
- (BOOL)windowShouldClose:(id)sender
{
	// ץꥱterminate
    [NSApp terminate:self];
    return YES;
}

@end
